﻿using SocketTest.Models;
using SocketTest.Sockets;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using SocketTest.Helpers;
using System.Diagnostics;

namespace SocketTest
{
    public partial class Form1 : Form
    {

        Server server;

        bool isRun;

        BindingSource peerlist_bs = new BindingSource();

        public Form1()
        {
            InitializeComponent();

            //grd_PeerList.DoubleBuffered(true);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.FormClosing += Form1_FormClosing;

            server = new Server();
            server.Connected += Server_Connected;
            server.Disconnected += Server_Disconnected;

            var tcpbindingList = new BindingList<Peer_Model>(server.Client_list);
            peerlist_bs.DataSource = tcpbindingList;
            grd_PeerList.DataSource = peerlist_bs;

            grd_PeerList.DataError += Grd_PeerList_DataError;
        }

        private void Grd_PeerList_DataError(object sender, DataGridViewDataErrorEventArgs e)
        { }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            isRun = false;
        }

        private void Server_Connected(Peer_Model peer)
        {
            Debug.WriteLine(server.Client_list.Count());

            Refresh_PeerList();
        }

        private void Server_Disconnected(Peer_Model peer)
        {
            Debug.WriteLine(server.Client_list.Count());

            Refresh_PeerList();
        }

        void Refresh_PeerList()
        {
            grd_PeerList.BeginInvoke(new Action(() =>
            {
                lock (server.Client_list)
                    peerlist_bs.ResetBindings(false);
            }));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            isRun = true;

            var th = new Thread(Client_Proc);
            th.Start();
        }

        void Client_Proc()
        {
            var client = new Client();

            while (isRun)
            {
                client.Connect(new IPEndPoint(IPAddress.Loopback, 4500));
                Thread.Sleep(1);
            }

            client.Dispose();
            client = null;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            isRun = false;
        }
    }
}
