﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Text;

namespace SocketTest.Helpers
{
    static class SocketHelper
    {

        public static byte[] ReadFromSocket(Socket sock, int len)
        {
            byte[] buffer = new byte[len];//이미지 길이만큼의 버퍼 생성
            int trans = 0;

            using (var stream = new NetworkStream(sock))
            {
                while (trans < len)//수신할 이미지 데이터가 남아있으면
                    trans += stream.Read(buffer, trans, len - trans);
            }

            return buffer;
        }

        public static void SetKeepAlive(Socket socket, UInt32 keepAliveInterval = 20000, UInt32 retryInterval = 2000)
        {
            int size = sizeof(UInt32);
            UInt32 on = 1;
            //UInt32 keepAliveInterval = 20000;   // Send a packet once every 10 seconds.
            //UInt32 retryInterval = 2000;        // If no response, resend every second.
            byte[] inArray = new byte[size * 3];
            Array.Copy(BitConverter.GetBytes(on), 0, inArray, 0, size);
            Array.Copy(BitConverter.GetBytes(keepAliveInterval), 0, inArray, size, size);
            Array.Copy(BitConverter.GetBytes(retryInterval), 0, inArray, size * 2, size);

            socket.IOControl(IOControlCode.KeepAliveValues, inArray, null);

        }

        public static bool IsConnected(this Socket socket)
        {
            if (socket == null) return false;

            try
            {
                if (!socket.Connected) return false;
                return !(socket.Poll(1, SelectMode.SelectRead) && socket.Available == 0);
            }
            catch (Exception)
            {
                return false;
            }
        }

    }
}
